"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var meta_1 = require("../meta");
var TestBase = (function () {
    function TestBase() {
    }
    return TestBase;
}());
var Meta = meta_1.$Meta(TestBase);
describe('Meta', function () {
    it('Meta data is not required', function () {
        new Meta();
        new Meta({});
        new Meta({ node: {} });
    });
    it('Can set metadata', function () {
        var meta = new Meta({
            node: {
                title: 'Hello World',
                description: 'Hello World example',
                metadata: {
                    x: 1,
                    y: 2,
                },
            },
        });
        chai_1.expect(meta.title).to.equal('Hello World');
        chai_1.expect(meta.description).to.equal('Hello World example');
        chai_1.expect(meta.metadata).to.deep.equal({
            x: 1,
            y: 2,
        });
    });
    it('Can set metadata through methods', function () {
        var meta = new Meta();
        meta.setTitle('Hello World');
        meta.setDescription('Hello World example');
        meta.setMetadata({
            x: 1,
            y: 2,
        });
        chai_1.expect(meta.title).to.equal('Hello World');
        chai_1.expect(meta.description).to.equal('Hello World example');
        chai_1.expect(meta.metadata).to.deep.equal({
            x: 1,
            y: 2,
        });
    });
    it('Can set metadata through method chaining', function () {
        var meta = new Meta();
        meta
            .setTitle('Hello World')
            .setDescription('Hello World example')
            .setMetadata({
            x: 1,
            y: 2,
        });
        chai_1.expect(meta.title).to.equal('Hello World');
        chai_1.expect(meta.description).to.equal('Hello World example');
        chai_1.expect(meta.metadata).to.deep.equal({
            x: 1,
            y: 2,
        });
    });
});
//# sourceMappingURL=meta.spec.js.map