"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var loader_1 = require("@chix/loader");
var port_1 = require("../sandbox/port");
var mockDependencyLoader = new loader_1.MockDependencyLoader();
function createPortBox(nodeDefinition, fn, name) {
    var portBox = new port_1.PortBox(name);
    portBox.set('state', nodeDefinition.state);
    portBox.set('output', {});
    if (nodeDefinition.dependencies && nodeDefinition.dependencies.npm) {
        portBox.addDependencies(nodeDefinition.dependencies.npm, mockDependencyLoader);
    }
    var strippedFunction = fn.slice(fn.indexOf('{') + 1, fn.lastIndexOf('}'));
    portBox.compile(strippedFunction);
    return portBox;
}
exports.createPortBox = createPortBox;
//# sourceMappingURL=createPortBox.js.map