"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var loader_1 = require("@chix/loader");
var uuid = require("uuid");
var context_1 = require("../context");
var handler_1 = require("../io/handler");
var node_1 = require("../node");
var process_1 = require("../process");
var BaseFlow_1 = require("./BaseFlow");
var mixin_1 = require("./mixin");
function FlowMix(Base) {
    return mixin_1.FlowMixin(Base);
}
var Flow = (function (_super) {
    __extends(Flow, _super);
    function Flow(id, node, loader, ioHandler, processManager, dependencyLoader, guardInstantiation) {
        if (loader === void 0) { loader = new loader_1.Loader(); }
        if (ioHandler === void 0) { ioHandler = new handler_1.IoHandler(); }
        if (processManager === void 0) { processManager = new process_1.ProcessManager(); }
        if (dependencyLoader === void 0) { dependencyLoader = new loader_1.RequireDependencyLoader(); }
        if (guardInstantiation === void 0) { guardInstantiation = false; }
        var _this = _super.call(this, {
            id: id,
            node: node,
            ioHandler: ioHandler,
            loader: loader,
            processManager: processManager,
            dependencyLoader: dependencyLoader,
        }) || this;
        _this.type = 'flow';
        _this.contextProvider = new context_1.DefaultContextProvider();
        _this._delay = 0;
        _this.active = false;
        _this.runCount = 0;
        _this._interval = 100;
        _this._inputTimeout = null;
        _this.nodeTimeout = 3000;
        _this.inputTimeout = 3000;
        if (!guardInstantiation) {
            throw Error('Use `await Flow.create()` to instantiate a new Flow');
        }
        _this.Self = Flow;
        if (!id) {
            throw Error('xFlow requires an id');
        }
        if (!node) {
            throw Error('xFlow requires a map');
        }
        _this.setLoader(loader);
        _this.setIoHandler(ioHandler);
        _this.setProcessManager(processManager);
        _this.setDependencyLoader(dependencyLoader);
        _this._node = __assign(__assign({}, node), { id: id });
        return _this;
    }
    Flow.create = function (id, node, loader, ioHandler, processManager, dependencyLoader) {
        return __awaiter(this, void 0, void 0, function () {
            var flow;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        flow = new Flow(id, node, loader, ioHandler, processManager, dependencyLoader, true);
                        return [4, flow.initAsync()];
                    case 1:
                        _a.sent();
                        return [2, flow];
                }
            });
        });
    };
    Flow.registerNodeType = function (Type) {
        ;
        this.nodeTypes[Type.name] = Type;
    };
    Flow.prototype.init = function () { };
    Flow.prototype.initAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var node;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        node = this._node;
                        if (node.nodeTimeout) {
                            this.nodeTimeout = node.nodeTimeout;
                        }
                        if (node.inputTimeout) {
                            this.inputTimeout = node.inputTimeout;
                        }
                        if (node.ports) {
                            this.ports = JSON.parse(JSON.stringify(node.ports));
                        }
                        if (node.main) {
                            node.nodes = node.nodes.map(function (_node) {
                                if (!_node.id) {
                                    return __assign(__assign({}, _node), { id: uuid.v4() });
                                }
                                return _node;
                            });
                        }
                        return [4, this.addMap(node)];
                    case 1:
                        _a.sent();
                        this.createPorts(this.ports);
                        this.setStatus('created');
                        return [2];
                }
            });
        });
    };
    Flow.nodeTypes = {
        xNode: node_1.xNode,
    };
    return Flow;
}(FlowMix(BaseFlow_1.BaseFlow)));
exports.Flow = Flow;
//# sourceMappingURL=flow.js.map