"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var _debug = require("debug");
var util = require("util");
var common_1 = require("../common");
var link_1 = require("../link");
var util_1 = require("../util");
var validate_1 = require("../validate");
var link_2 = require("./link");
var loader_1 = require("./loader");
var node_1 = require("./node");
var process_1 = require("./process");
var debug = _debug('chix:actor');
function $Map(Base) {
    return (function (_super) {
        __extends(Map$, _super);
        function Map$() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.view = [];
            return _this;
        }
        Map$.prototype.addMap = function (flowDefinition) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, _b, link, _c, _d, node;
                var e_1, _e, e_2, _f;
                var _this = this;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            debug('%s: addMap()', this.identifier);
                            try {
                                validate_1.validate.flow(flowDefinition);
                            }
                            catch (error) {
                                if (flowDefinition.title) {
                                    throw Error("Flow `" + flowDefinition.title + "`: " + error.message);
                                }
                                else {
                                    console.error(flowDefinition);
                                    throw Error("Flow " + flowDefinition.ns + ":" + flowDefinition.name + ": " + error.message);
                                }
                            }
                            if (flowDefinition.id) {
                                this.id = flowDefinition.id;
                            }
                            if (flowDefinition.nodeDefinitions) {
                                this.loader.addNodeDefinitions('@', flowDefinition.nodeDefinitions);
                            }
                            return [4, Promise.all(flowDefinition.nodes.map(function (node) { return __awaiter(_this, void 0, void 0, function () {
                                    var nodeDefinition;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (!node.id) {
                                                    throw new Error(util.format('Node lacks an id: %s:%s', node.ns, node.name));
                                                }
                                                if (!node.provider) {
                                                    if (flowDefinition.providers &&
                                                        flowDefinition.providers.hasOwnProperty('@')) {
                                                        node.provider = flowDefinition.providers['@'].url;
                                                    }
                                                }
                                                return [4, this.loader.getNodeDefinition(node, flowDefinition)];
                                            case 1:
                                                nodeDefinition = (_a.sent());
                                                if (!nodeDefinition) {
                                                    throw new Error(util.format('Failed to get node definition for %s:%s', node.ns, node.name));
                                                }
                                                debug('%s: Creating node %s:%s', this.identifier, node.ns, node.name);
                                                return [2, this.createNode(node, nodeDefinition)];
                                        }
                                    });
                                }); }))];
                        case 1:
                            _g.sent();
                            if (flowDefinition.hasOwnProperty('links')) {
                                try {
                                    for (_a = __values(flowDefinition.links), _b = _a.next(); !_b.done; _b = _a.next()) {
                                        link = _b.value;
                                        this.addLink(link_1.Link.create(link));
                                    }
                                }
                                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                finally {
                                    try {
                                        if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                                    }
                                    finally { if (e_1) throw e_1.error; }
                                }
                            }
                            try {
                                for (_c = __values(flowDefinition.nodes), _d = _c.next(); !_d.done; _d = _c.next()) {
                                    node = _d.value;
                                    this.view.push(node.id);
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (_d && !_d.done && (_f = _c.return)) _f.call(_c);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            this.setStatus('created');
                            if (!this.pid) {
                                this.processManager.register(this);
                            }
                            return [2, this];
                    }
                });
            });
        };
        return Map$;
    }(Base));
}
exports.$Map = $Map;
(function ($Map) {
    function create(Base) {
        return util_1.mixin($Map, common_1.$Identity.create, link_2.$Link.create, loader_1.$Loader.create, node_1.$Node.create, process_1.$Process.create, common_1.$Status.create)(Base);
    }
    $Map.create = create;
})($Map = exports.$Map || (exports.$Map = {}));
//# sourceMappingURL=map.js.map