"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var _debug = require("debug");
var util = require("util");
var common_1 = require("../common");
var context_1 = require("../context");
var events_1 = require("../events");
var handler_1 = require("../io/handler");
var util_1 = require("../util");
var validate_1 = require("../validate");
var port_1 = require("./port");
var ports_1 = require("./ports");
var process_1 = require("./process");
var shutdown_1 = require("./shutdown");
var debug = _debug('chix:actor');
function $Node(Base) {
    return (function (_super) {
        __extends(Node$, _super);
        function Node$() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.nodes = new Map();
            _this.ioHandler = new handler_1.IoHandler();
            _this.contextProvider = new context_1.DefaultContextProvider();
            return _this;
        }
        Node$.prototype.createNode = function (node, nodeDefinition) {
            return __awaiter(this, void 0, void 0, function () {
                var identifier, _node, flow, cls, nodeTypes;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!nodeDefinition) {
                                throw new Error(util.format('Failed to get node definition for %s:%s', node.ns, node.name));
                            }
                            if (!node.id) {
                                throw Error('Node should have an id');
                            }
                            if (this.hasNode(node.id)) {
                                console.log('Warning: Node already added, skipping... FIXME');
                                this.event(events_1.FlowEvents.ADD_NODE, { node: this.getNode(node.id) });
                                return [2, this.getNode(node.id)];
                            }
                            if (!nodeDefinition.ports) {
                                nodeDefinition.ports = {};
                            }
                            if (node.title) {
                                nodeDefinition.title = node.title;
                            }
                            if (node.description) {
                                nodeDefinition.description = node.description;
                            }
                            identifier = node.title || [node.ns, '::', node.name, '-', this.nodes.size].join('');
                            if (!(nodeDefinition.type === 'flow')) return [3, 2];
                            flow = node;
                            if (!flow.id) {
                                throw Error('Flow id missing');
                            }
                            return [4, this.create(flow.id, node, nodeDefinition)];
                        case 1:
                            _node = _a.sent();
                            _node.identifier = identifier;
                            this.nodes.set(flow.id, _node);
                            debug('%s: created %s', this.identifier, _node.identifier);
                            return [3, 7];
                        case 2:
                            cls = nodeDefinition.type || 'xNode';
                            nodeTypes = this.constructor.nodeTypes;
                            if (!nodeTypes.hasOwnProperty(cls)) return [3, 6];
                            validate_1.validate.nodeDefinition(nodeDefinition);
                            if (!nodeDefinition.dependencies) return [3, 4];
                            return [4, this.dependencyLoader.load(nodeDefinition.dependencies)];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4:
                            _node = new nodeTypes[cls](node.id, nodeDefinition);
                            _node.identifier = identifier;
                            _node.setDependencyLoader(this.dependencyLoader);
                            return [4, _node.initAsync()];
                        case 5:
                            _a.sent();
                            this.nodes.set(node.id, _node);
                            debug('%s: created %s', this.identifier, _node.identifier);
                            this.processManager.register(_node);
                            if (_node.hasShutdown()) {
                                _node.on('execute', function () {
                                    console.log('will execute');
                                });
                            }
                            return [3, 7];
                        case 6: throw Error(util.format('Unknown node type: `%s`', cls));
                        case 7:
                            _node.setParent(this);
                            if (node.provider) {
                                _node.provider = node.provider;
                            }
                            if (node.context) {
                                this.contextProvider.addContext(_node, node.context, nodeDefinition.ports.input);
                            }
                            this.event(events_1.FlowEvents.ADD_NODE, { node: _node });
                            return [2, _node];
                    }
                });
            });
        };
        Node$.prototype.create = function (_id, _flow, flowDefinition) {
            return __awaiter(this, void 0, void 0, function () {
                var node;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            console.error('Fix me: Not merging external ports');
                            validate_1.validate.flow(flowDefinition);
                            return [4, this.Self.create(_id, flowDefinition, this.loader, this.ioHandler, this.processManager, this.dependencyLoader)];
                        case 1:
                            node = _a.sent();
                            return [4, node.initAsync()];
                        case 2:
                            _a.sent();
                            return [2, node];
                    }
                });
            });
        };
        Node$.prototype.addNode = function (node, nodeDefinition) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.createNode(node, nodeDefinition)];
                        case 1:
                            _a.sent();
                            return [2, this];
                    }
                });
            });
        };
        Node$.prototype.renameNode = function (_nodeId) {
            throw Error('renameNode not implemented');
        };
        Node$.prototype.removeNode = function (nodeId) {
            return __awaiter(this, void 0, void 0, function () {
                var oldNode;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.processManager.unregister(this.getNode(nodeId))];
                        case 1:
                            _a.sent();
                            oldNode = this.getNode(nodeId).export();
                            this.nodes.delete(nodeId);
                            this.event(events_1.FlowEvents.REMOVE_NODE, {
                                node: oldNode,
                            });
                            return [2];
                    }
                });
            });
        };
        Node$.prototype.removeNodes = function () {
            this.clear();
        };
        Node$.prototype.getNodes = function () {
            return Array.from(this.nodes.values());
        };
        Node$.prototype.hasNode = function (id) {
            return this.nodes.has(id);
        };
        Node$.prototype.getNode = function (id) {
            var e_1, _a;
            if (this.nodes.has(id)) {
                return this.nodes.get(id);
            }
            else {
                try {
                    for (var _b = __values(this.nodes.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var node = _c.value;
                        if (node.id === id || node.identifier === id) {
                            return node;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            if (id === this.id) {
                return this;
            }
            throw new Error(util.format('Node %s does not exist', id));
        };
        return Node$;
    }(Base));
}
exports.$Node = $Node;
(function ($Node) {
    function create(Base) {
        return util_1.mixin($Node, common_1.$Event.create, common_1.$Identity.create, port_1.$Port.create, ports_1.$Ports.create, process_1.$Process.create, shutdown_1.$Shutdown.create)(Base);
    }
    $Node.create = create;
})($Node = exports.$Node || (exports.$Node = {}));
//# sourceMappingURL=node.js.map