"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../common");
var node_1 = require("../sandbox/node");
var util_1 = require("../util");
var control_1 = require("./control");
var dependency_1 = require("./dependency");
var output_1 = require("./output");
var port_1 = require("./port");
function $Nodebox(Base) {
    return (function (_super) {
        __extends(Nodebox$, _super);
        function Nodebox$() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._delay = 0;
            _this.async = false;
            _this.interval = 100;
            _this.inputTimeout = 3000;
            _this.nodeTimeout = 3000;
            var node = util_1.getNodeArgument(args).node;
            if (node.expose) {
                _this.expose = node.expose;
            }
            if (node.dependencies) {
                _this.dependencies = node.dependencies;
            }
            if (node.nodeTimeout) {
                _this.nodeTimeout = node.nodeTimeout;
            }
            if (node.inputTimeout) {
                _this.inputTimeout = node.inputTimeout;
            }
            if (!_this.async) {
                if (node.async) {
                    _this.async = node.async;
                }
            }
            _this.nodeDefinition = node;
            return _this;
        }
        Nodebox$.prototype.setupNodeBox = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.nodebox = new node_1.NodeBox(this.ns + "_" + this.name);
                    this.nodebox.set('done', this.complete.bind(this));
                    this.nodebox.set('cb', this._asyncOutput.bind(this));
                    this.nodebox.set('state', this.state);
                    if (this.dependencies && this.dependencies.npm) {
                        this.nodebox.addDependencies(this.dependencies.npm, this.dependencyLoader);
                    }
                    if (this.expose) {
                        this.nodebox.expose(this.expose);
                    }
                    this.nodebox.set('output', this.async ? this._asyncOutput.bind(this) : {});
                    if (!this.nodeDefinition.ports) {
                        throw Error('Node definition does not contain any ports.');
                    }
                    if (this.nodeDefinition.hasOwnProperty('fn')) {
                        this.fn = this.nodeDefinition.fn;
                    }
                    if (this.nodeDefinition.ports.input) {
                        if (this._isPreloaded(this.nodeDefinition.ports.input)) {
                            if (this.fn) {
                                this.nodebox.fill(this.fn);
                            }
                            if (this.async) {
                                this.nodebox.state = this.nodeDefinition.state;
                            }
                        }
                        else {
                            if (this.fn !== undefined) {
                                this.nodebox.compile(this.fn);
                            }
                            if (this.async) {
                                this.nodebox.run();
                            }
                        }
                    }
                    this.state = this.nodebox.state;
                    return [2];
                });
            });
        };
        Nodebox$.prototype._isPreloaded = function (inputPorts) {
            if (typeof this.fn === 'function') {
                return true;
            }
            for (var port in inputPorts) {
                if (inputPorts.hasOwnProperty(port)) {
                    if (inputPorts[port].fn) {
                        return true;
                    }
                }
            }
            return false;
        };
        return Nodebox$;
    }(Base));
}
exports.$Nodebox = $Nodebox;
(function ($Nodebox) {
    function create(Base) {
        return util_1.mixin($Nodebox, common_1.$Identity.create, control_1.$Control.create, dependency_1.$Dependency.create, output_1.$Output.create, port_1.$Port.create)(Base);
    }
    $Nodebox.create = create;
})($Nodebox = exports.$Nodebox || (exports.$Nodebox = {}));
//# sourceMappingURL=nodebox.js.map