"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var iobox_1 = require("@chix/iobox");
function _underscored(str) {
    return str
        .replace(/([a-z\d])([A-Z]+)/g, '$1_$2')
        .replace(/[.-\s]+/g, '_')
        .toLowerCase();
}
var NodeBox = (function (_super) {
    __extends(NodeBox, _super);
    function NodeBox(name) {
        var _this = _super.call(this, name) || this;
        _this.name = 'NodeBox';
        if (name) {
            _this.name = name;
        }
        _this.define();
        return _this;
    }
    NodeBox.prototype.define = function () {
        this.addArg('input', {});
        this.addArg('$', {});
        this.addArg('output', {});
        this.addArg('state', {});
        this.addArg('done', null);
        this.addArg('cb', null);
        this.addArg('on', {
            input: {},
        });
        this.addReturn('output');
        this.addReturn('state');
        this.addReturn('on');
    };
    NodeBox.prototype.addDependencies = function (dependencies, dependencyLoader, check) {
        var e_1, _a;
        if (check === void 0) { check = true; }
        var packagePaths = Object.keys(dependencies);
        try {
            for (var packagePaths_1 = __values(packagePaths), packagePaths_1_1 = packagePaths_1.next(); !packagePaths_1_1.done; packagePaths_1_1 = packagePaths_1.next()) {
                var packagePath = packagePaths_1_1.value;
                var u_key = _underscored(packagePath.split('/').pop());
                if (dependencyLoader.hasDependency(packagePath) || !check) {
                    this.addArg(u_key, dependencyLoader.require(packagePath));
                    this.emit('require', { require: packagePath });
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (packagePaths_1_1 && !packagePaths_1_1.done && (_a = packagePaths_1.return)) _a.call(packagePaths_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    NodeBox.prototype.expose = function (exposed) {
        var e_2, _a;
        var _global = typeof window === 'undefined' ? global : window;
        if (exposed) {
            try {
                for (var exposed_1 = __values(exposed), exposed_1_1 = exposed_1.next(); !exposed_1_1.done; exposed_1_1 = exposed_1.next()) {
                    var expose = exposed_1_1.value;
                    this.emit('expose', { expose: expose });
                    if (expose === 'window') {
                        this.addArg('win', window);
                    }
                    else if (expose === 'self') {
                        this.addArg('self', this);
                    }
                    else {
                        if (!this.args.hasOwnProperty(expose)) {
                            this.addArg(expose, _global[expose]);
                        }
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (exposed_1_1 && !exposed_1_1.done && (_a = exposed_1.return)) _a.call(exposed_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    };
    NodeBox.prototype.compile = function (fn) {
        return _super.prototype.compile.call(this, fn, true);
    };
    NodeBox.prototype.run = function (bind) {
        var res = _super.prototype.run.apply(this, [bind]);
        var ret;
        for (var k in res) {
            if (k === 'return') {
                ret = res.return;
            }
            else if (res.hasOwnProperty(k)) {
                this.set(k, res[k]);
            }
        }
        return ret;
    };
    return NodeBox;
}(iobox_1.IOBox));
exports.NodeBox = NodeBox;
//# sourceMappingURL=node.js.map