"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var events_2 = require("./events");
var Setting = (function (_super) {
    __extends(Setting, _super);
    function Setting(settings) {
        var _this = _super.call(this) || this;
        _this.setting = {};
        if (settings) {
            _this.configure(settings);
        }
        return _this;
    }
    Setting.prototype.configure = function (settings) {
        if (settings === void 0) { settings = {}; }
        for (var key in settings) {
            if (settings.hasOwnProperty(key)) {
                this.set(key, settings[key]);
            }
        }
    };
    Setting.prototype.clearSettings = function () {
        this.setting = {};
    };
    Setting.prototype.set = function (name, val) {
        if (undefined !== val) {
            this.setting[name] = val;
            this.emit(events_2.SettingEvents.CHANGE, this, 'setting', this.setting);
        }
    };
    Setting.prototype.get = function (name) {
        return this.setting ? this.setting[name] : undefined;
    };
    Setting.prototype.del = function (name) {
        if (this.setting && this.setting.hasOwnProperty(name)) {
            delete this.setting[name];
        }
    };
    Setting.prototype.has = function (name) {
        return this.setting && this.setting.hasOwnProperty(name);
    };
    return Setting;
}(events_1.EventEmitter));
exports.Setting = Setting;
//# sourceMappingURL=setting.js.map