"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ValidationError_1 = require("./ValidationError");
function getPortsIfExists(type, node, nodeDefinitions) {
    var nodeDefinition = nodeDefinitions[node.ns][node.name];
    if (!nodeDefinition) {
        throw new ValidationError_1.ValidationError("NodeDefinitions " + node.ns + ":" + node.name + " does not exist.");
    }
    if (!nodeDefinition.ports || Object.keys(nodeDefinition.ports).length === 0) {
        throw new ValidationError_1.ValidationError("NodeDefinitions " + node.ns + ":" + node.name + " has no ports.");
    }
    var ports = nodeDefinition.ports[type];
    if (!ports || Object.keys(ports).length === 0) {
        throw new ValidationError_1.ValidationError("NodeDefinitions " + node.ns + ":" + node.name + " has no " + type + " ports.");
    }
    return ports;
}
exports.getPortsIfExists = getPortsIfExists;
//# sourceMappingURL=getPortsIfExists.js.map